RaamatukoguAPP11/RaamatukoguAPP11/Controllers/EksemplarsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using RaamatukoguAPP11;
using System.IO;
using Newtonsoft.Json;
using PagedList;


namespace RaamatukoguAPP11
{
    public partial class Eksemplar
    {
        public bool KasSaadaval
        {
            get => Saadaval == 1;
            set => Saadaval = value ? 1 : 0;
        }

        string _Isbn = "";
        string _Tiitel = "";
        string _Autor = "";
        string _Aasta = "";
        byte[] _Pilt = null;

        int _Kategooria = 0;

        public string Isbn//Raamatu loomiseks vajalik property, et eksemplari kaudu saaks raamatu mudelile ligi
        {
            get => RaamatuKood == 0 ? _Isbn : Raamat.Isbn;
            set => _Isbn = value;
        }
        public string UIsbn => _Isbn;//Raamatu muutmiseks vajalik property (U ehk uus)

        public string Tiitel
        {
            get => RaamatuKood == 0 ? _Tiitel : Raamat.Tiitel;
            set => _Tiitel = value;
        }
        public string UTiitel => _Tiitel;
        public string Autor
        {
            get => RaamatuKood == 0 ? _Autor : Raamat.Autor;
            set => _Autor = value;
        }
        public string UAutor => _Autor;
        public string Aasta
        {
            get => RaamatuKood == 0 ? _Aasta : Raamat.Aasta;
            set => _Aasta = value;
        }
        public string UAasta => _Aasta;
        public byte[] Pilt
        {
            get => RaamatuKood == 0 ? _Pilt : Raamat.Pilt;
            set => _Pilt = value;
        }
        public byte[] UPilt => _Pilt;

        public int Kategooria
        {
            get => RaamatuKood == 0 ? _Kategooria : Raamat.Kategooria.Kood;
            set => _Kategooria = value;
        }
        public int UKategooria => _Kategooria;
    }
}
namespace RaamatukoguAPP11.Controllers
{
    public class EksemplarsController : Controller
    {
        private RaamatukoguEntities db = new RaamatukoguEntities();

        public ActionResult EksPilt(int? id)
        {
            if (id == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            Eksemplar e = db.Eksemplar.Find(id.Value);
            if (e == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            if (e.Pilt?.Length == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            var pilt = e.Pilt.ToArray();
            return File(pilt, "image/jpg");
        }

        [Authorize]
        // GET: Eksemplars
        public ActionResult Index(string sortOrder, string currentFilter, string searching, int? page)
        {
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            var eksemplar = db.Eksemplar.Include(e => e.KasutajaH).Include(e => e.Raamat).Include(e => e.KasutajaO).ToList().Where(y => y.Omanik == k.Kood);

            ViewBag.CurrentSort = sortOrder;
            ViewBag.TiitliSort = String.IsNullOrEmpty(sortOrder) ? "Tiitel_desc" : "";
            ViewBag.AutoriSort = String.IsNullOrEmpty(sortOrder) ? "Autor_desc" : "";
            ViewBag.KategooriaSort = String.IsNullOrEmpty(sortOrder) ? "Kategooria_desc" : "";

            if (searching != null)
            {
                page = 1;
            }
            else
            {
                searching = currentFilter;
            }
            ViewBag.CurrentFilter = searching;

            if (Kasutaja.ByEmail(User.Identity.Name) != null)
            {

                if (!String.IsNullOrEmpty(searching))
                {
                    eksemplar = eksemplar
                        .Where(x => x.Raamat.Tiitel.ToUpper().Contains(searching.ToUpper())
                        || x.Raamat.Autor.ToUpper().Contains(searching.ToUpper())
                        || x.Raamat.Kategooria.Kategooria1.ToUpper().Contains(searching.ToUpper())
                        /*|| searching == null*/);
                }

                switch (sortOrder)
                {
                    case "Tiitel_desc":
                        eksemplar = eksemplar.OrderByDescending(e => e.Raamat.Tiitel);
                        break;
                    case "Autor":
                        eksemplar = eksemplar.OrderBy(e => e.Raamat.Autor);
                        break;
                    case "Autor_desc":
                        eksemplar = eksemplar.OrderByDescending(e => e.Raamat.Autor);
                        break;
                    case "Kategooria":
                        eksemplar = eksemplar.OrderBy(e => e.Raamat.Kategooria.Kategooria1);
                        break;
                    case "Kategooria_desc":
                        eksemplar = eksemplar.OrderByDescending(e => e.Raamat.Kategooria.Kategooria1);
                        break;
                    default:
                        eksemplar = eksemplar.OrderBy(e => e.Raamat.Tiitel);
                        break;
                }

                int pageSize = 3;
                int pageNumber = (page ?? 1);
                return View(eksemplar.ToPagedList(pageNumber, pageSize));
            }


            else
                return RedirectToAction("Index", "Home");
        }

        [Authorize]
        // GET: Eksemplars/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Eksemplar eksemplar = db.Eksemplar.Find(id);
            if (eksemplar == null)
            {
                return HttpNotFound();
            }

            return View(eksemplar);
        }

        [Authorize]
        // GET: Eksemplars/Create/id
        public ActionResult Create(long? id)
        {
            ViewBag.Raamatud = db.Raamat.ToList();
            Raamat r = db.Raamat.Find(id ?? -1);
            Eksemplar e = new Eksemplar();
            if (id != null) { e.Isbn = "x" + id.ToString(); } // genereerib ISBN koodi, GenereeriIsbnEks meetodi abil. Tundub, et id ei jookse konflikti. Kui midagi juhtub, siis seetõttu, et GenereeriIsbnEks annab id-ks uue väärtuse. 
      
            if (r == null)
            {
                ViewBag.RaamatuKood = new SelectList(db.Raamat.OrderBy(x=>x.Tiitel), "Kood", "Tiitel");//dropdown list on tähestiku järjekorras
            }
            else
            {
                e.RaamatuKood = r.Kood;
                ViewBag.RaamatuKood = new SelectList(db.Raamat, "Kood", "Tiitel", e.RaamatuKood);
            }

            ViewBag.Kategooria = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1");

            Kasutaja ka = Kasutaja.ByEmail(User.Identity.Name);
            ViewBag.Hoidja = new SelectList(db.Kasutaja, "Kood", "Email", ka.Kood);
            ViewBag.Omanik = new SelectList(db.Kasutaja, "Kood", "Email", ka.Kood);

            Silt s = db.Silt.Find(ka.Kood);
            ViewBag.Sildid = db.Silt.Where(x => x.KasutajaKood == ka.Kood).ToList();

            return View("Create",e);
        }
        
        public ActionResult GenereeriIsbnEks()
        {            
            Random random = new Random();
            string r = "";
            for (int i = 1; i < 13; i++)
            {
                r += random.Next(0, 9).ToString();
            }
            return Create((long.Parse(r)));
        }

        [Authorize]
        // POST: Eksemplars/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Kood,RaamatuKood,Isbn,Tiitel,Autor,Aasta,Pilt,Kategooria,Omanik,Hoidja,AsukohaKommentaar,Kapp,Riiul,Saadaval,KasSaadaval")] Eksemplar eksemplar, HttpPostedFileBase file)
        {
            Kasutaja ka = Kasutaja.ByEmail(User.Identity.Name);
            eksemplar.Omanik = ka.Kood;

            if (ModelState.IsValid)
            {
                if (file != null && file.ContentLength > 0)
                {
                    using (BinaryReader br = new BinaryReader(file.InputStream))
                    {
                        byte[] buff = br.ReadBytes(file.ContentLength);
                        eksemplar.Pilt = buff;
                    }
                }

                db.Eksemplar.Add(eksemplar);
                if (eksemplar.RaamatuKood == 0)
                {
                    Raamat u = db.Raamat.Where(x => x.Tiitel == eksemplar.Tiitel).Take(1).SingleOrDefault();
                    if (u == null)
                    {
                        Kategooria k = db.Kategooria.Where(y => y.Kood == eksemplar.Kategooria).Take(1).SingleOrDefault();
                        
                        db.Raamat.Add(u = new Raamat { Tiitel = eksemplar.Tiitel, Autor = eksemplar.Autor, Isbn=eksemplar.Isbn, Aasta=eksemplar.Aasta, Pilt=eksemplar.Pilt, KategooriaKood=k.Kood});
                        db.SaveChanges();
                    }
                    u.Eksemplar.Add(eksemplar);
                }
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            
            ViewBag.Kategooria = new SelectList(db.Kategooria, "Kood", "Kategooria1", eksemplar.Kategooria);
            ViewBag.RaamatuKood = new SelectList(db.Raamat, "Kood", "Tiitel", eksemplar.RaamatuKood);
            ViewBag.RaamatuKood = new SelectList(db.Raamat, "Kood", "RaamatuKood", eksemplar.RaamatuKood);
            //TODO: Üks ülemistest viewbagidest on ülearune

            ViewBag.Hoidja = new SelectList(db.Kasutaja, "Kood", "Email", ka.Kood);
            ViewBag.Omanik = new SelectList(db.Kasutaja, "Kood", "Email", ka.Kood);
            return View(eksemplar);
        }

        [Authorize]
        // GET: Eksemplars/Edit/5

RaamatukoguAPP11/RaamatukoguAPP11/Views/Eksemplars/Create.cshtml
@model RaamatukoguAPP11.Eksemplar


@{
    ViewBag.Title = "UusKirje";
}

<h2>Loo uus kirje</h2>


@using (Html.BeginForm("Create", "Eksemplars", FormMethod.Post, new { enctype = "multipart/form-data" })) // parameetreid on vaja juhul kui create nupp ei lähe create actionresulti. Anname jõuliselt ette.
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Uue eksemplari loomine</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })

        <div class="form-group">
            @Html.LabelFor(model => model.RaamatuKood, "Vali olemasolev raamat", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("RaamatuKood", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.RaamatuKood, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Isbn, "Isbn (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })

            <div class="col-md-10">
                @Html.EditorFor(model => model.Isbn, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ActionLink("Kliki siin, kui raamatul ei ole ISBN koodi", "GenereeriIsbnEks")
                @Html.ValidationMessageFor(model => model.Isbn, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Tiitel, "Tiitel (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Tiitel, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Tiitel, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Autor, "Autor (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Autor, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Autor, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Aasta, "Aasta (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Aasta, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Aasta, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Pilt, "Pilt (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })

            <div class="col-md-10">
                <img src='@Url.Action("RaamatuPilt", "Raamats", new { id = Model.Kood } )' height="300" />
            </div>
            <div class="col-md-10">
                @*<label for="file">Vaheta pilt:</label>*@
                <input type="file" name="file" id="file" class="btn btn-default" />
            </div>

            @*<div class="col-md-10">
                @Html.EditorFor(model => model.Pilt, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Pilt, "", new { @class = "text-danger" })
            </div>*@
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Kategooria, "Kategooria (uus raamat)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Kategooria", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Kategooria, "", new { @class = "text-danger" })
            </div>
        </div>

            <div class="col-md-10">
                <table>
                    <tr>
                        <td valign="top">
                            <p>Saadaolevad sildid:</p>
                            <ul type="circle">
                                @foreach (Silt s in ViewBag.Sildid ?? new List<Silt>())
                            {
                            if (!s.EksemplariSilt.Select(x => x.EksemplariKood).Contains(Model.Kood))
                            {
                                <li>@Html.ActionLink("+ " + s.Silt1, "LisaSilt", new { id = Model.Kood * 1000 + s.Kood })</li>
                            }
                            }
                            </ul>
                        </td>
                        <td valign="top">
                            <p>Eksemplaril on sildid:</p>
                            <ul type="circle">
                                @foreach (EksemplariSilt es in Model.EksemplariSilt.Where(x => x.SildiKood != 0))
                                {
                            <li>@Html.ActionLink("- " + es.Silt.Silt1, "EemaldaSilt", new { id = Model.Kood * 1000 + es.SildiKood })</li>
                                }
                            </ul>
                        </td>
                    </tr>
                </table>
            </div>

        @*<div class="form-group">
            @Html.LabelFor(model => model.Omanik, "Omanik", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Omanik, new { htmlAttributes = new { @class = "form-control" } })
                @Html.DropDownList("Omanik", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Omanik, "", new { @class = "text-danger" })
            </div>
        </div>*@

        <div class="form-group">
            @Html.LabelFor(model => model.Hoidja, "Hoidja", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @*@Html.EditorFor(model => model.Hoidja, new { htmlAttributes = new { @class = "form-control" } })*@
                @Html.DropDownList("Hoidja", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Hoidja, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.AsukohaKommentaar,"Asukoha kommentaar", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextAreaFor(model => model.AsukohaKommentaar, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.AsukohaKommentaar, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Kapp, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Kapp, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Kapp, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Riiul, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Riiul, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Riiul, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Saadaval, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.KasSaadaval, new { htmlAttributes = new { @class = "checkbox" } })
                @Html.ValidationMessageFor(model => model.KasSaadaval, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Sisesta" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Minu raamatute nimekiri", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

RaamatukoguAPP11/RaamatukoguAPP11/Views/Eksemplars/Edit.cshtml
@model RaamatukoguAPP11.Eksemplar

@{
    ViewBag.Title = "MuudaRaamatut";
}

<h2>Muuda raamatut</h2>


@using (Html.BeginForm("Edit", "Eksemplars", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Eksemplar</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Kood)

        @*See lõik teeb dropdown listi. Lihtsalt kontrolliks ok, aga kasutada EI TOHI*@
        <div class="form-group">
            @*@Html.LabelFor(model => model.RaamatuKood, "(raamatuKoodi kontroll)", htmlAttributes: new { @class = "control-label col-md-2" })*@
            @*<div class="col-md-10">*@
                @Html.HiddenFor(model => model.RaamatuKood, new { htmlAttributes = new { @class = "form-control" } })
                @*@Html.DisplayFor(model => model.RaamatuKood, new { htmlAttributes = new { @class = "form-control" } })*@
                @*@Html.DropDownList("RaamatuKood", null, htmlAttributes: new { @class = "form-control" })*@
                @*@Html.ValidationMessageFor(model => model.RaamatuKood, "", new { @class = "text-danger" })*@
            @*</div>*@
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Isbn, "Isbn (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Isbn, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Isbn, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Tiitel, "Tiitel (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Tiitel, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Tiitel, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Autor, "Autor (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Autor, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Autor, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Aasta, "Aasta (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Aasta, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Aasta, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Pilt, "Pilt (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <img src='@Url.Action("EksPilt", "Eksemplars", new { id = Model.Kood } )' height="300" />
            </div>
            <div class="col-md-10">
                @*<label for="file">Vaheta pilt:</label>*@
                <input type="file" name="file" id="file" class="btn btn-default" />
            </div>
            
            @*<div class="col-md-10">
                @Html.EditorFor(model => model.Pilt, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Pilt, "", new { @class = "text-danger" })
            </div>*@
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Kategooria, "Kategooria (muudanRmt)", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Kategooria", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Kategooria, "", new { @class = "text-danger" })
            </div>
        </div>


        
        <div class="col-md-10">
            <table>
                <tr>
                    <td valign="top">
                        <p>Saadaolevad sildid:</p>
                        <ul type="circle">
                            @foreach (Silt s in ViewBag.Sildid ?? new List<Silt>())
                            {
                                if (!s.EksemplariSilt.Select(x => x.EksemplariKood).Contains(Model.Kood))
                                {
                                    <li>@Html.ActionLink("+ " + s.Silt1, "LisaSilt", new { id = Model.Kood * 1000 + s.Kood })</li>
                                }
                            }
                        </ul>
                    </td>
                    <td valign="top">
                        <p>Eksemplaril on sildid:</p>
                        <ul type="circle">
                            @foreach (EksemplariSilt es in Model.EksemplariSilt.Where(x => x.SildiKood != 0))
                            {
                                <li>@Html.ActionLink("- " + es.Silt.Silt1, "EemaldaSilt", new { id = Model.Kood * 1000 + es.SildiKood })</li>
                            }
                        </ul>
                    </td>
                </tr>
            </table>
        </div>



        @*<div class="form-group">
            @Html.LabelFor(model => model.Omanik, "Omanik", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Omanik", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Omanik, "", new { @class = "text-danger" })
            </div>
        </div>*@

        <div class="form-group">
            @Html.LabelFor(model => model.Hoidja, "Hoidja", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Hoidja", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Hoidja, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.AsukohaKommentaar, "Asukoha kommentaar", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextAreaFor(model => model.AsukohaKommentaar, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.AsukohaKommentaar, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Kapp, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Kapp, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Kapp, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Riiul, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Riiul, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Riiul, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Saadaval, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.KasSaadaval, new { htmlAttributes = new { @class = "checkbox" } })
                @Html.ValidationMessageFor(model => model.KasSaadaval, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Muuda" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Minu raamatute nimekiri", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}